######################################################################
# npage_viewer.inc.pl
#  ꤷܥڡ̾ΡǻϤޤڡ¤٤ɽޤ
#   ۤ/1 Ϥ
#   ۤ/2 ۤδ
#   ۤ/2.1 ܤ­
#   ۤ/3 ۤγ
#  Τ褦ʥڡnŤɽޤ
#
# #npage_viewer(ܥڡ̾, ڡ, ⡼, ѥ졼)
#  ⡼ɤ reverseеսɽ̵̤ˡ
#  ѥ졼ϥڡֹ˺äƤƤ褤ʸǥեȤ'.'
#
# 2006-03-18 modified by tenk*
# YashiganiModokicalendar_viewer.inc.plξ¤ʪ
# ǸŪˤʤ֤ɡܿͤΥȤΤȤ⤢...
# Ȥꤢʤβ˴ؤƤϼĥ̵ʤΤǡƼȽǤǤ
# 
######################################################################


# calendar_viewer.inc.pl te_st
use strict;

# # # # # # # # # # #
# ߤäȤʤȴ, _convert  _action إڡ֤̾ѿ򤳤Ѱաby tenk*
my $npage_viewer_start_page='';
my $npage_viewer_end_page='';


sub plugin_npage_viewer_convert {
	my $show_pagename=1;
	my ($pagebase, $limit_page, $mode, $numb_sep) = split(/,/, shift);
	$numb_sep = '.' if ($numb_sep eq '');

	my $body = '';
	my @pagelist;
	my $pagepattern;
	my $pagepattern_len;

	if ($pagebase eq '') {
		$pagepattern = '';
	} else {
		$pagepattern = $pagebase.'/';
	}
	$pagepattern_len = length($pagepattern);

	foreach my $page (sort keys %::database) {
		next if (substr($page,0,$pagepattern_len) ne $pagepattern);

		my $page_string = substr($page,$pagepattern_len);
		next if ($page_string !~ /^\d+/);

		push(@pagelist, $page);
	}

	my @sortedpagelist;
	if ($mode eq 'reverse') {
		@sortedpagelist = reverse sort @pagelist;
	} else {
		@sortedpagelist = sort @pagelist;
	}
	my $itemnum = @sortedpagelist;

	my $enc_pagename = &encode(substr($pagepattern, 0, $pagepattern_len - 1));

	# 󥯺
	my $s_numb_sep = htmlspecialchars($numb_sep);
	my $left_link;
	my $right_link;
	my ($limit_base, $limit_pitch);
	my $this_sep;

	$limit_page =~ s/ //g;
	my $numb_sep_len   = length($numb_sep);
	my $limit_page_len = length($limit_page);

	# nɽ
	if ($limit_page =~ /^\d+$/) {		# ΤߤΤȤ
		$limit_base  = 0;
		$limit_pitch = $limit_page;
	} elsif ($limit_page =~ /^(\d+)\*(\d+)$/) {		# ڡܤ
		$limit_page  = $1 + $2;
		$limit_base  = $1;
		$limit_pitch = $2;
	} else {						# 狼ʤä顢Ȥꤢ1
		$limit_page  = 1;
		$limit_base  = 0;
		$limit_pitch = $limit_page;
	}

	my $right_page;
	if ($limit_page < $itemnum) {
		my $right_base = $limit_base + $limit_pitch;
		$right_page    = $right_base ."*".$limit_pitch;
	}

	my $left_page;
	my $left_base = $limit_base - $limit_pitch;
	if ($left_base >= 0) {
		$left_page   = $left_base . "*" . $limit_pitch;
	}

	if ($mode eq 'reverse') {
		my  $tmp    = $left_page;
		$left_page  = $right_page;
		$right_page = $tmp;
	}

	if ($left_page ne ''){
		my $left_text = sprintf('&lt;&lt;%d', $limit_pitch);
		$left_link = "<a href=\"$::script?cmd=npage_viewer&amp;mymsg=$enc_pagename&amp;numb=$left_page&amp;numb_sep=$s_numb_sep&amp;mode=$mode\">$left_text</a>";
	}else{
		$left_link = '';
	}
	if ($right_page ne ''){
		my $right_text = sprintf('%d&gt;&gt;', $limit_pitch);
		$right_link = "<a href=\"$::script?cmd=npage_viewer&amp;mymsg=$enc_pagename&amp;numb=$right_page&amp;numb_sep=$s_numb_sep&amp;mode=$mode\">$right_text</a>";
	}else {
		$right_link = '';
	}

	# 2006-02-24 ˤ󥯤Ѱ
	$body .= "<table width =\"100%\"><tr><td align=\"left\">";
	$body .= $left_link;
	$body .= "</td><td align=\"right\">";
	$body .= $right_link;
	$body .= "</td></tr></table>";

	# Τɽ
	$npage_viewer_start_page = '';
	$npage_viewer_end_page   = '';
	my $backup_mypage = $::form{mypage};				#push
	my $count = $limit_base;
	my $disp_num = 0;
	while ($count < $limit_page) {
		last if ($count >= $itemnum);
		my $page = $sortedpagelist[$count];
		if (&is_exist_page($page)) {
			$npage_viewer_start_page = $page if ($npage_viewer_start_page eq '');
			$npage_viewer_end_page   = $page;
			$::form{mypage} = $page;
			if ($show_pagename) {
				my $page_string = substr($page,$pagepattern_len);
				my $cookedpage  = &encode($page);
				my $escapedpage = &htmlspecialchars($page_string);
				$body .= "<h1 class=\"npage_viewer_pagename\"><a href=\"$::script?cmd=read&amp;mypage=$cookedpage\">$escapedpage</a></h1>\n";
			}
			$body .= &text_to_html($::database{$page}, toc=>1);
			$body .= "<br /><br /><br />";				# 2006-02-24 add by tenk*
			++$count;
			++$disp_num;
		}
	}
	$::form{mypage} = $backup_mypage;					#pop

	# ǡΥ󥯤ɽ
	if ($disp_num > 0) {
		$body .= "<table width =\"100%\"><tr><td align=\"left\">";
		$body .= $left_link;
		$body .= "</td><td align=\"right\">";
		$body .= $right_link;
		$body .= "</td></tr></table>";
	}
	return $body;
}


sub plugin_npage_viewer_action {
	my $page     = &escape($::form{mymsg});
	my $page_num = &escape($::form{numb});
	my $mode     = &escape($::form{mode});
	my $numb_sep = &escape($::form{numb_sep});

	# ̵꤬ϡ1
	$page_num     = 1 if ($page_num eq '');

	# ѥ졼ΥǥեȤ.
	$numb_sep    = '.' if ($numb_sep eq '');

	my $body     = &plugin_npage_viewer_convert(qq($page,$page_num,$mode,$numb_sep));

	my $return_vars = htmlspecialchars($page);
	$return_vars .= "/" if ($page ne '');

	# ڡϰ
	$npage_viewer_start_page =~ s/$return_vars//;
	if ($npage_viewer_start_page =~ /^(\d[\d$numb_sep]*)/) {
		$npage_viewer_start_page = $1;
	}
	$npage_viewer_end_page   =~ s/$return_vars//;
	if ($npage_viewer_end_page =~ /^(\d[\d$numb_sep]*)/) {
		$npage_viewer_end_page = $1;
	}
	if ($npage_viewer_start_page gt $npage_viewer_end_page) {
		my $tmp = $npage_viewer_end_page;
		$npage_viewer_end_page   = $npage_viewer_start_page;
		$npage_viewer_start_page = $tmp;
	}
	$return_vars .= $npage_viewer_start_page;
	if ($npage_viewer_start_page ne $npage_viewer_end_page) {
		$return_vars .= "$npage_viewer_end_page";
	}

	$::form{mypage}=$return_vars;

	return ('msg'=>$return_vars, 'body'=>$body, 'ispage'=>1 );
}
1;

__END__

